<?php
/*******************************************************************************

    This file is part of AceEditor.

    AceEditor is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    AceEditor is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

    Diese Datei ist Teil von AceEditor.

    AceEditor ist Freie Software: Sie können es unter den Bedingungen
    der GNU General Public License, wie von der Free Software Foundation,
    Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren
    veröffentlichten Version, weiterverbreiten und/oder modifizieren.

    AceEditor wird in der Hoffnung, dass es nützlich sein wird, aber
    OHNE JEDE GEWÄHELEISTUNG, bereitgestellt; sogar ohne die implizite
    Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
    Siehe die GNU General Public License für weitere Details.

    Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
    Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.

	AUTHOR: 	Christian Meißner (christian.meissner@mono-graph.de)
	VERSION:	0.1
	DATE:		2012-09-19
	
*******************************************************************************/

# get correct id for plugin
$thisfile=basename(__FILE__, ".php");

# register plugin
register_plugin(
	$thisfile, 							# ID of plugin, should be filename minus php
	'AceEditor', 						# Title of plugin
	'0.1', 								# Version of plugin
	'Christian Meißner',				# Author of plugin
	'http://www.mono-graph.de', 		# Author URL
	'Ace Code Editor for Components', 	# Plugin Description
	'plugins', 							# Page type of plugin
	''  								# Function that displays content
);

define('AEPATH',        GSPLUGINPATH.$thisfile.'/');
define('AEURL',         $SITEURL.'/plugins/'.$thisfile.'/');
define('AEPLUGINCFG',   GSDATAOTHERPATH . $thisfile . '.xml');

# hook into components view (component-extras)
add_action('component-extras', 'ae_hook');

# register ace script for backend
register_script('ace', 'http://d1n0x3qji82z53.cloudfront.net/src-min-noconflict/ace.js', '1', FALSE);
queue_script('ace', GSBACK);

# register plugin javascript for backend
register_script('AceEditor', $SITEURL . '/plugins/AceEditor/aceeditor.js' , '0.1', FALSE);
queue_script('AceEditor', GSBACK);

# register plugin style for backend
register_style('AceEditor', $SITEURL.'/plugins/AceEditor/aceeditor.css', '0.1', 'screen');
queue_style('AceEditor', GSBACK);

# component extras hook
function ae_hook()
{
    global $table;
	global $count;

	$table .= '<script type="text/javascript">jQuery(document).ready(function() { init_ace_editor('.$count.'); });</script>';	
}
