/*******************************************************************************

    This file is part of AceEditor.

    AceEditor is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    AceEditor is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

    Diese Datei ist Teil von AceEditor.

    AceEditor ist Freie Software: Sie können es unter den Bedingungen
    der GNU General Public License, wie von der Free Software Foundation,
    Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren
    veröffentlichten Version, weiterverbreiten und/oder modifizieren.

    AceEditor wird in der Hoffnung, dass es nützlich sein wird, aber
    OHNE JEDE GEWÄHELEISTUNG, bereitgestellt; sogar ohne die implizite
    Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
    Siehe die GNU General Public License für weitere Details.

    Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
    Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.

	AUTHOR: 	Christian Meißner (christian.meissner@mono-graph.de)
	VERSION:	0.1
	DATE:		2012-09-19	
	
*******************************************************************************/

/**
 * Ace Editor initialization
 * @param   num id of component section
 */
function init_ace_editor(num) {
	var id  = "ace-editor-" + num;
	var cid = "section-" + num;

	// test for ace 
	if (window.ace === undefined) return;
    
	// hide org textarea of component div
	$("#" + cid + " textarea").hide();

	// append ace editor container to component div
	$("#" + cid).append('<div class="ace_editor_container"><div id="' + id + '"></div></div>');

	// copy content of textarea to ace editor
	$("#" + id).html($("#" + cid + " textarea").html());

	// init ace editor
	var editor = window.ace.edit(id);

	// set theme and language
	editor.setTheme("ace/theme/ambiance");
	editor.getSession().setMode("ace/mode/php");

	// copy contents of ace editor to org textarea on change
	editor.getSession().on("change", function(e) {
		$("#" + cid + " textarea").html(editor.getValue());
	});
}

/**
 * Plugin JS initialization
 */
jQuery(document).ready(function() {
    // init new ace editor on add component click
    // small time is delay necessary
	$("#addcomponent").click(function() {
		setTimeout(function() {
			var id = ($("#id").val()) - 1;		
            init_ace_editor(id);
        }, 1);
		
	});
});
